aboutsummaryrefslogtreecommitdiff
path: root/ci/common
diff options
context:
space:
mode:
Diffstat (limited to 'ci/common')
-rw-r--r--ci/common/build.sh89
-rw-r--r--ci/common/suite.sh199
-rw-r--r--ci/common/test.sh174
3 files changed, 462 insertions, 0 deletions
diff --git a/ci/common/build.sh b/ci/common/build.sh
new file mode 100644
index 0000000000..f398a1a1cc
--- /dev/null
+++ b/ci/common/build.sh
@@ -0,0 +1,89 @@
+top_make() {
+ ${MAKE_CMD} "$@"
+}
+
+build_make() {
+ top_make -C "${BUILD_DIR}" "$@"
+}
+
+build_deps() {
+ if test "${BUILD_32BIT}" = ON ; then
+ DEPS_CMAKE_FLAGS="${DEPS_CMAKE_FLAGS} ${CMAKE_FLAGS_32BIT}"
+ fi
+ if test "${FUNCTIONALTEST}" = "functionaltest-lua" \
+ || test "${CLANG_SANITIZER}" = "ASAN_UBSAN" ; then
+ DEPS_CMAKE_FLAGS="${DEPS_CMAKE_FLAGS} -DUSE_BUNDLED_LUA=ON"
+ fi
+
+ rm -rf "${DEPS_BUILD_DIR}"
+
+ # If there is a valid cache and we're not forced to recompile,
+ # use cached third-party dependencies.
+ if test -f "${CACHE_MARKER}" && test "${BUILD_NVIM_DEPS}" != "true" ; then
+ local statcmd="stat -c '%y'"
+ if test "${TRAVIS_OS_NAME}" = osx ; then
+ statcmd="stat -f '%Sm'"
+ fi
+ echo "Using third-party dependencies from Travis's cache (last updated: $(${statcmd} "${CACHE_MARKER}"))."
+
+ mkdir -p "$(dirname "${DEPS_BUILD_DIR}")"
+ mv "${HOME}/.cache/nvim-deps" "${DEPS_BUILD_DIR}"
+ else
+ mkdir -p "${DEPS_BUILD_DIR}"
+ fi
+
+ # Even if we're using cached dependencies, run CMake and make to
+ # update CMake configuration and update to newer deps versions.
+ cd "${DEPS_BUILD_DIR}"
+ echo "Configuring with '${DEPS_CMAKE_FLAGS}'."
+ CC= cmake ${DEPS_CMAKE_FLAGS} "${TRAVIS_BUILD_DIR}/third-party/"
+
+ if ! top_make; then
+ exit 1
+ fi
+
+ cd "${TRAVIS_BUILD_DIR}"
+}
+
+prepare_build() {
+ if test -n "${CLANG_SANITIZER}" ; then
+ CMAKE_FLAGS="${CMAKE_FLAGS} -DCLANG_${CLANG_SANITIZER}=ON"
+ fi
+ if test "${BUILD_32BIT}" = ON ; then
+ CMAKE_FLAGS="${CMAKE_FLAGS} ${CMAKE_FLAGS_32BIT}"
+ fi
+
+ mkdir -p "${BUILD_DIR}"
+ cd "${BUILD_DIR}"
+ echo "Configuring with '${CMAKE_FLAGS} $@'."
+ cmake ${CMAKE_FLAGS} "$@" "${TRAVIS_BUILD_DIR}"
+}
+
+build_nvim() {
+ echo "Building nvim."
+ if ! top_make nvim ; then
+ exit 1
+ fi
+
+ if test "$CLANG_SANITIZER" != "TSAN" ; then
+ echo "Building libnvim."
+ if ! top_make libnvim ; then
+ exit 1
+ fi
+
+ echo "Building nvim-test."
+ if ! top_make nvim-test ; then
+ exit 1
+ fi
+ fi
+
+ # Invoke nvim to trigger *San early.
+ if ! (bin/nvim --version && bin/nvim -u NONE -e -c ':qall') ; then
+ asan_check "${LOG_DIR}"
+ exit 1
+ fi
+ asan_check "${LOG_DIR}"
+
+
+ cd "${TRAVIS_BUILD_DIR}"
+}
diff --git a/ci/common/suite.sh b/ci/common/suite.sh
new file mode 100644
index 0000000000..d3fbcd1eda
--- /dev/null
+++ b/ci/common/suite.sh
@@ -0,0 +1,199 @@
+# HACK: get newline for use in strings given that "\n" and $'' do not work.
+NL="$(printf '\nE')"
+NL="${NL%E}"
+
+FAIL_SUMMARY=""
+
+# Test success marker. If END_MARKER file exists, we know that all tests
+# finished. If FAIL_SUMMARY_FILE exists we know that some tests failed, this
+# file will contain information about failed tests. Build is considered
+# successful if tests ended without any of them failing.
+END_MARKER="$BUILD_DIR/.tests_finished"
+FAIL_SUMMARY_FILE="$BUILD_DIR/.test_errors"
+
+ANSI_CLEAR="\033[0K"
+
+travis_fold() {
+ local action="$1"
+ local name="$2"
+ name="$(echo -n "$name" | tr '\n\0' '--' | sed 's/[^A-Za-z0-9]\{1,\}/-/g')"
+ name="$(echo -n "$name" | sed 's/-$//')"
+ echo -en "travis_fold:${action}:${name}\r${ANSI_CLEAR}"
+}
+
+if test "$TRAVIS" != "true" ; then
+ travis_fold() {
+ return 0
+ }
+fi
+
+enter_suite() {
+ set +x
+ FAILED=0
+ rm -f "${END_MARKER}"
+ local suite_name="$1"
+ export NVIM_TEST_CURRENT_SUITE="${NVIM_TEST_CURRENT_SUITE}/$suite_name"
+ travis_fold start "${NVIM_TEST_CURRENT_SUITE}"
+ set -x
+}
+
+exit_suite() {
+ set +x
+ if test -f "$NVIM_LOG_FILE" ; then
+ printf "===============================================================================\n"
+ printf "NVIM_LOG_FILE: $NVIM_LOG_FILE\n"
+ cat "$NVIM_LOG_FILE" 2>/dev/null || printf '(empty)'
+ printf "\n"
+ rm -rf "$NVIM_LOG_FILE"
+ fi
+ travis_fold end "${NVIM_TEST_CURRENT_SUITE}"
+ if test $FAILED -ne 0 ; then
+ echo "Suite ${NVIM_TEST_CURRENT_SUITE} failed, summary:"
+ echo "${FAIL_SUMMARY}"
+ fi
+ export NVIM_TEST_CURRENT_SUITE="${NVIM_TEST_CURRENT_SUITE%/*}"
+ if test "$1" != "--continue" ; then
+ exit $FAILED
+ else
+ local saved_failed=$FAILED
+ FAILED=0
+ return $saved_failed
+ fi
+}
+
+fail() {
+ local test_name="$1"
+ local fail_char="$2"
+ local message="$3"
+
+ : ${fail_char:=F}
+ : ${message:=Test $test_name failed}
+
+ local full_msg="$fail_char $NVIM_TEST_CURRENT_SUITE|$test_name :: $message"
+ FAIL_SUMMARY="${FAIL_SUMMARY}${NL}${full_msg}"
+ echo "${full_msg}" >> "${FAIL_SUMMARY_FILE}"
+ echo "Failed: $full_msg"
+ FAILED=1
+}
+
+run_test() {
+ local cmd="$1"
+ test $# -gt 0 && shift
+ local test_name="$1"
+ : ${test_name:=$cmd}
+ test $# -gt 0 && shift
+ if ! eval "$cmd" ; then
+ fail "${test_name}" "$@"
+ fi
+}
+
+run_test_wd() {
+ local hang_ok=
+ if test "$1" = "--allow-hang" ; then
+ hang_ok=1
+ shift
+ fi
+
+ local timeout="$1"
+ test $# -gt 0 && shift
+
+ local cmd="$1"
+ test $# -gt 0 && shift
+
+ local restart_cmd="$1"
+ : ${restart_cmd:=true}
+ test $# -gt 0 && shift
+
+ local test_name="$1"
+ : ${test_name:=$cmd}
+ test $# -gt 0 && shift
+
+ local output_file="$(mktemp)"
+ local status_file="$(mktemp)"
+ local sid_file="$(mktemp)"
+
+ local restarts=5
+ local prev_tmpsize=-1
+ while test $restarts -gt 0 ; do
+ : > "$status_file"
+ : > "$sid_file"
+ setsid \
+ env \
+ output_file="$output_file" \
+ status_file="$status_file" \
+ sid_file="$sid_file" \
+ cmd="$cmd" \
+ CI_DIR="$CI_DIR" \
+ sh -c '
+ . "${CI_DIR}/common/test.sh"
+ ps -o sid= > "$sid_file"
+ (
+ ret=0
+ if ! eval "$cmd" 2>&1 ; then
+ ret=1
+ fi
+ echo "$ret" > "$status_file"
+ ) | tee -a "$output_file"
+ '
+ while test "$(stat -c "%s" "$status_file")" -eq 0 ; do
+ prev_tmpsize=$tmpsize
+ sleep $timeout
+ tmpsize="$(stat -c "%s" "$output_file")"
+ if test $tempsize -eq $prev_temsize ; then
+ # no output, assuming either hang or exit
+ break
+ fi
+ done
+ restarts=$(( restarts - 1 ))
+ if test "$(stat -c "%s" "$status_file")" -eq 0 ; then
+ # Status file not updated, assuming hang
+
+ # SID not known, this should not ever happen
+ if test "$(stat -c "%s" "$sid_file")" -eq 0 ; then
+ fail "$test_name" E "Shell did not run"
+ break
+ fi
+
+ # Kill all processes which belong to one session: should get rid of test
+ # processes as well as sh itself.
+ pkill -KILL -s$(cat "$sid_file")
+
+ if test $restarts -eq 0 ; then
+ if test -z "$hang_ok" ; then
+ fail "$test_name" E "Test hang up"
+ fi
+ else
+ echo "Test ${test_name} hang up, restarting"
+ eval "$restart_cmd"
+ fi
+ else
+ local new_failed="$(cat "$status_file")"
+ if test "$new_failed" != "0" ; then
+ fail "$test_name" F "Test failed in run_test_wd"
+ fi
+ break
+ fi
+ done
+
+ rm -f "$output_file"
+ rm -f "$status_file"
+ rm -f "$sid_file"
+}
+
+ended_successfully() {
+ if test -f "${FAIL_SUMMARY_FILE}" ; then
+ echo 'Test failed, complete summary:'
+ cat "${FAIL_SUMMARY_FILE}"
+ return 1
+ fi
+ if ! test -f "${END_MARKER}" ; then
+ echo 'ended_successfully called before end marker was touched'
+ return 1
+ fi
+ return 0
+}
+
+end_tests() {
+ touch "${END_MARKER}"
+ ended_successfully
+}
diff --git a/ci/common/test.sh b/ci/common/test.sh
new file mode 100644
index 0000000000..55f76ca798
--- /dev/null
+++ b/ci/common/test.sh
@@ -0,0 +1,174 @@
+. "${CI_DIR}/common/build.sh"
+. "${CI_DIR}/common/suite.sh"
+
+print_core() {
+ local app="$1"
+ local core="$2"
+ if test "$app" = quiet ; then
+ echo "Found core $core"
+ return 0
+ fi
+ echo "======= Core file $core ======="
+ if test "${TRAVIS_OS_NAME}" = osx ; then
+ lldb -Q -o "bt all" -f "${app}" -c "${core}"
+ else
+ gdb -n -batch -ex 'thread apply all bt full' "${app}" -c "${core}"
+ fi
+}
+
+check_core_dumps() {
+ local del=
+ if test "$1" = "--delete" ; then
+ del=1
+ shift
+ fi
+ local app="${1:-${BUILD_DIR}/bin/nvim}"
+ if test "${TRAVIS_OS_NAME}" = osx ; then
+ local cores="$(find /cores/ -type f -print)"
+ else
+ local cores="$(find ./ -type f -name 'core.*' -print)"
+ fi
+
+ if test -z "${cores}" ; then
+ return
+ fi
+ local core
+ for core in $cores; do
+ if test "$del" = "1" ; then
+ print_core "$app" "$core" >&2
+ rm "$core"
+ else
+ print_core "$app" "$core"
+ fi
+ done
+ if test "$app" != quiet ; then
+ fail 'cores' E 'Core dumps found'
+ fi
+}
+
+check_logs() {
+ # Iterate through each log to remove an useless warning.
+ for log in $(find "${1}" -type f -name "${2}"); do
+ sed -i "${log}" \
+ -e '/Warning: noted but unhandled ioctl/d' \
+ -e '/could cause spurious value errors to appear/d' \
+ -e '/See README_MISSING_SYSCALL_OR_IOCTL for guidance/d'
+ done
+
+ # Now do it again, but only consider files with size > 0.
+ local err=""
+ for log in $(find "${1}" -type f -name "${2}" -size +0); do
+ cat "${log}"
+ err=1
+ done
+ if test -n "${err}" ; then
+ fail 'logs' E 'Runtime errors detected.'
+ fi
+}
+
+valgrind_check() {
+ check_logs "${1}" "valgrind-*"
+}
+
+asan_check() {
+ check_logs "${1}" "*san.*"
+}
+
+run_unittests() {(
+ enter_suite unittests
+ ulimit -c unlimited || true
+ if ! build_make unittest ; then
+ fail 'unittests' F 'Unit tests failed'
+ fi
+ check_core_dumps "$(which luajit)"
+ exit_suite
+)}
+
+run_functionaltests() {(
+ enter_suite functionaltests
+ ulimit -c unlimited || true
+ if ! build_make ${FUNCTIONALTEST}; then
+ fail 'functionaltests' F 'Functional tests failed'
+ fi
+ asan_check "${LOG_DIR}"
+ valgrind_check "${LOG_DIR}"
+ check_core_dumps
+ exit_suite
+)}
+
+run_oldtests() {(
+ enter_suite oldtests
+ ulimit -c unlimited || true
+ if ! make -C "${TRAVIS_BUILD_DIR}/src/nvim/testdir"; then
+ reset
+ fail 'oldtests' F 'Legacy tests failed'
+ fi
+ asan_check "${LOG_DIR}"
+ valgrind_check "${LOG_DIR}"
+ check_core_dumps
+ exit_suite
+)}
+
+check_runtime_files() {(
+ set +x
+ local test_name="$1" ; shift
+ local message="$1" ; shift
+ local tst="$1" ; shift
+
+ cd runtime
+ for file in $(git ls-files "$@") ; do
+ # Check that test is not trying to work with files with spaces/etc
+ # Prefer failing the build over using more robust construct because files
+ # with IFS are not welcome.
+ if ! test -e "$file" ; then
+ fail "$test_name" E \
+ "It appears that $file is only a part of the file name"
+ fi
+ if ! test "$tst" "$INSTALL_PREFIX/share/nvim/runtime/$file" ; then
+ fail "$test_name" F "$(printf "$message" "$file")"
+ fi
+ done
+)}
+
+install_nvim() {(
+ enter_suite 'install_nvim'
+ if ! build_make install ; then
+ fail 'install' E 'make install failed'
+ exit_suite
+ fi
+
+ "${INSTALL_PREFIX}/bin/nvim" --version
+ if ! "${INSTALL_PREFIX}/bin/nvim" -u NONE -e -c ':help' -c ':qall' ; then
+ echo "Running ':help' in the installed nvim failed."
+ echo "Maybe the helptags have not been generated properly."
+ fail 'help' F 'Failed running :help'
+ fi
+
+ # Check that all runtime files were installed
+ check_runtime_files \
+ 'runtime-install' \
+ 'It appears that %s is not installed.' \
+ -e \
+ '*.vim' '*.ps' '*.dict' '*.py' '*.tutor'
+
+ # Check that some runtime files are installed and are executables
+ check_runtime_files \
+ 'not-exe' \
+ 'It appears that %s is not installed or is not executable.' \
+ -x \
+ '*.awk' '*.sh' '*.bat'
+
+ # Check that generated syntax file has function names, #5060.
+ local genvimsynf=syntax/vim/generated.vim
+ local gpat='syn keyword vimFuncName .*eval'
+ if ! grep -q "$gpat" "${INSTALL_PREFIX}/share/nvim/runtime/$genvimsynf" ; then
+ fail 'funcnames' F "It appears that $genvimsynf does not contain $gpat."
+ fi
+
+ exit_suite
+)}
+
+csi_clean() {
+ find "${BUILD_DIR}/bin" -name 'test-includes-*' -delete
+ find "${BUILD_DIR}" -name '*test-include*.o' -delete
+}